Imports Microsoft.VisualBasic

Imports DotNetNuke.Common.Utilities

Namespace effority.UserDirectory

   Public Class UserIdAndUserName

      Private _UserId As Int32
      Private _UserName As String
      Private _Email As String
      Private _DisplayName As String

      Public Property UserId() As Int32
         Get
            Return _UserId
         End Get
         Set(ByVal value As Int32)
            _UserId = value
         End Set
      End Property

      Public Property UserName() As String
         Get
            Return _UserName
         End Get
         Set(ByVal value As String)
            _UserName = value
         End Set
      End Property

      Public Property Email() As String
         Get
            Return _Email
         End Get
         Set(ByVal value As String)
            _Email = value
         End Set
      End Property

      Public Property DisplayName() As String
         Get
            Return _DisplayName
         End Get
         Set(ByVal value As String)
            _DisplayName = value
         End Set
      End Property

      Public Sub New(ByVal UserId As Int32, ByVal UserName As String, ByVal Email As String)

         _UserId = UserId
         _UserName = UserName
         _Email = Email

      End Sub

      Public Sub New(ByVal UserId As Int32, ByVal UserName As String, ByVal Email As String, ByVal DisplayName As String)

         _UserId = UserId
         _UserName = UserName
         _Email = Email
         _DisplayName = DisplayName

      End Sub

   End Class

   Public Class UserRoles

      Private _UserRoleId As Integer
      Private _RoleId As Integer
      Private _UserId As Integer
      Private _EffectiveDate As Date
      Private _ExpiryDate As Date

      Public Property UserRolesId() As Integer
         Get
            Return _UserRoleId
         End Get
         Set(ByVal value As Integer)
            _UserRoleId = value
         End Set
      End Property

      Public Property RoleId() As Integer
         Get
            Return _RoleId
         End Get
         Set(ByVal value As Integer)
            _RoleId = value
         End Set
      End Property

      Public Property UserId() As Integer
         Get
            Return _UserId
         End Get
         Set(ByVal value As Integer)
            _UserId = value
         End Set
      End Property

      Public Property EffectiveDate() As Date
         Get
            Return _EffectiveDate
         End Get
         Set(ByVal value As Date)
            _EffectiveDate = value
         End Set
      End Property

      Public Property ExpiryDate() As Date
         Get
            Return _ExpiryDate
         End Get
         Set(ByVal value As Date)
            _ExpiryDate = value
         End Set
      End Property

      Public ReadOnly Property DateValid() As Boolean
         Get

            Dim valid As Boolean = False

            If _EffectiveDate = Null.NullDate And _ExpiryDate = Null.NullDate Then

               valid = True

            ElseIf _EffectiveDate = Null.NullDate And _ExpiryDate <> Null.NullDate Then

               ' Ablaufdatum gesetzt
               If Now < _ExpiryDate Then
                  valid = True
               End If

            ElseIf _ExpiryDate = Null.NullDate And _EffectiveDate <> Null.NullDate Then

               ' Beginndatum gesetzt 
               If Now < _EffectiveDate Then
                  valid = True
               End If

            Else

               ' Beginndatum und Ablaufdatum gesetzt 
               If Now > _EffectiveDate And Now < _ExpiryDate Then
                  valid = True
               End If

            End If

            Return valid

         End Get

      End Property

      Public Sub New()

      End Sub

      Public Sub New(ByVal UserRoleId As Integer, ByVal UserId As Integer, ByVal RoleId As Integer, ByVal EffectiveDate As Date, ByVal ExpiryDate As Date)

         _UserRoleId = UserRoleId
         _UserId = UserId
         _RoleId = RoleId
         _EffectiveDate = EffectiveDate
         _ExpiryDate = ExpiryDate

      End Sub

   End Class

   Public Class UserPortals

      Private _UserPortalId As Int32
      Private _UserId As Int32
      Private _PortalId As Int32
      Private _CreatedDate As DateTime
      Private _Autherised As Boolean

      Public Property UserPortalId() As Integer
         Get
            Return _UserPortalId
         End Get
         Set(ByVal value As Integer)
            _UserPortalId = value
         End Set
      End Property

      Public Property UserId() As Integer
         Get
            Return _UserId
         End Get
         Set(ByVal value As Integer)
            _UserId = value
         End Set
      End Property

      Public Property PortalId() As Integer
         Get
            Return _PortalId
         End Get
         Set(ByVal value As Integer)
            _PortalId = value
         End Set
      End Property

      Public Property CreatedDate() As Date
         Get
            Return _CreatedDate
         End Get
         Set(ByVal value As Date)
            _CreatedDate = value
         End Set
      End Property

      Public Property Autherised() As Boolean
         Get
            Return _Autherised
         End Get
         Set(ByVal value As Boolean)
            _Autherised = value
         End Set
      End Property

   End Class

   Public Class ProfilePropertyDefinition

      Private _PropertyDefinitionID As Integer
      Private _PortalId As Integer
      Private _DefaultValue As String
      Private _PropertyCategory As String
      Private _PropertyName As String
      Private _Visible As Boolean

      Public Property PropertyDefinitionID() As Integer
         Get
            Return _PropertyDefinitionID
         End Get
         Set(ByVal value As Integer)
            _PropertyDefinitionID = value
         End Set
      End Property

      Public Property PortalId() As Integer
         Get
            Return _PortalId
         End Get
         Set(ByVal value As Integer)
            _PortalId = value
         End Set
      End Property

      Public Property DefaultValue() As String
         Get
            Return _DefaultValue
         End Get
         Set(ByVal value As String)
            _DefaultValue = value
         End Set
      End Property

      Public Property PropertyCategory() As String
         Get
            Return _PropertyCategory
         End Get
         Set(ByVal value As String)
            _PropertyCategory = value
         End Set
      End Property

      Public Property PropertyName() As String
         Get
            Return _PropertyName
         End Get
         Set(ByVal value As String)
            _PropertyName = value
         End Set
      End Property

      Public Property Visible() As Boolean
         Get
            Return _Visible
         End Get
         Set(ByVal value As Boolean)
            _Visible = value
         End Set
      End Property
   End Class

   Public Class UserProfile

      Private _ProfileId As Integer
      Private _UserId As Integer
      Private _PropertyDefinitionId As Integer
      Private _PropertyValue As String
      Private _PropertyText As String
      Private _Visibility As Integer

      Public Property ProfileId() As Integer
         Get
            Return _ProfileId
         End Get
         Set(ByVal value As Integer)
            _ProfileId = value
         End Set
      End Property

      Public Property UserId() As Integer
         Get
            Return _UserId
         End Get
         Set(ByVal value As Integer)
            _UserId = value
         End Set
      End Property

      Public Property PropertyDefinitionId() As Integer
         Get
            Return _PropertyDefinitionId
         End Get
         Set(ByVal value As Integer)
            _PropertyDefinitionId = value
         End Set
      End Property

      Public Property PropertyValue() As String
         Get
            Return _PropertyValue
         End Get
         Set(ByVal value As String)
            _PropertyValue = value
         End Set
      End Property

      Public Property PropertyText() As String
         Get
            Return _PropertyText
         End Get
         Set(ByVal value As String)
            _PropertyText = value
         End Set
      End Property

      Public Property Visibility() As Integer
         Get
            Return _Visibility
         End Get
         Set(ByVal value As Integer)
            _Visibility = value
         End Set
      End Property

   End Class

   Public Class VCardInfo
      Inherits DotNetNuke.Services.Tokens.BaseTokenReplace

#Region " Private Members "

      'Private _FirstName As String
      'Private _LastName As String

      Private _Username As String
      Private _DisplayName As String
      Private _Email As String

      Private _ProfileProperties As New Generic.Dictionary(Of String, String)

#End Region

#Region " Public Properties "


      'Public Property Firstname() As String
      '   Get
      '      Return _FirstName
      '   End Get
      '   Set(ByVal value As String)
      '      _FirstName = value
      '   End Set
      'End Property

      'Public Property LastName() As String
      '   Get
      '      Return _LastName
      '   End Get
      '   Set(ByVal value As String)
      '      _LastName = value
      '   End Set
      'End Property

      Public Property Username() As String
         Get
            Return _Username
         End Get
         Set(ByVal value As String)
            _Username = value
         End Set
      End Property

      Public Property DisplayName() As String
         Get
            Return _DisplayName
         End Get
         Set(ByVal value As String)
            _DisplayName = value
         End Set
      End Property

      Public Property Email() As String
         Get
            Return _Email
         End Get
         Set(ByVal value As String)
            _Email = value
         End Set
      End Property

      Public Property ProfileProperties() As Generic.Dictionary(Of String, String)
         Get
            Return _ProfileProperties
         End Get
         Set(ByVal value As Generic.Dictionary(Of String, String))
            _ProfileProperties = value
         End Set
      End Property

#End Region

#Region " Contructors "

      Public Sub New()

      End Sub

      Public Sub New(ByVal user As DotNetNuke.Entities.Users.UserInfo)

         'Me._FirstName = user.FirstName
         'Me._LastName = user.LastName

         If user IsNot Nothing Then

            Me._DisplayName = user.DisplayName
            Me._Username = user.Username
            Me._Email = user.Email

            For Each proPro As DotNetNuke.Entities.Profile.ProfilePropertyDefinition In user.Profile.ProfileProperties

               Me._ProfileProperties.Add(proPro.PropertyName, CStr(proPro.PropertyValue))

            Next

         End If

      End Sub

#End Region

#Region " Methods "

      Public Function Replace(ByVal str As String) As String
         Return MyBase.ReplaceTokens(str)
      End Function

      Protected Overrides Function replacedTokenValue(ByVal strObjectName As String, ByVal strPropertyName As String, ByVal strFormat As String) As String

         Dim result As String = String.Empty

         If strFormat = String.Empty Then strFormat = "g"

         If strObjectName.ToLower = "profile" Then

            Select Case strPropertyName.ToLower

               Case "displayname"

                  result = Me._DisplayName

               Case "email"

                  result = Me._Email

               Case "username"

                  result = Me._Username

                  'Case "lastname"
                  '   result = cCardCode & ":" & Me._FirstName

                  'Case "firstname"
                  '   result = cCardCode & ":" & Me._LastName

               Case Else

                  If Me.ProfileProperties.TryGetValue(strPropertyName, Nothing) Then

                     result = Me.ProfileProperties(strPropertyName)

                  End If

            End Select


         End If


         Return result

      End Function

#End Region

   End Class

   Public Class DetailInfo
      Inherits DotNetNuke.Services.Tokens.BaseTokenReplace

#Region " Private Members "

      Private _FirstName As String
      Private _LastName As String

      Private _Username As String
      Private _DisplayName As String
      Private _Email As String

      Private _UserId As Int32

      Private _ProfileProperties As New Generic.Dictionary(Of String, DotNetNuke.Entities.Profile.ProfilePropertyDefinition)

      Private _Base As effority.UserDirectory.Base

      Private _RenderMode As Enums.ReplaceEngineRenderMode

#End Region

#Region " Public Properties "

      Public Property Firstname() As String
         Get
            Return _FirstName
         End Get
         Set(ByVal value As String)
            _FirstName = value
         End Set
      End Property

      Public Property LastName() As String
         Get
            Return _LastName
         End Get
         Set(ByVal value As String)
            _LastName = value
         End Set
      End Property

      Public Property UserId() As Int32
         Get
            Return _UserId
         End Get
         Set(ByVal value As Int32)
            _UserId = value
         End Set
      End Property

      Public Property Username() As String
         Get
            Return _Username
         End Get
         Set(ByVal value As String)
            _Username = value
         End Set
      End Property

      Public Property DisplayName() As String
         Get
            Return _DisplayName
         End Get
         Set(ByVal value As String)
            _DisplayName = value
         End Set
      End Property

      Public Property Email() As String
         Get
            Return _Email
         End Get
         Set(ByVal value As String)
            _Email = value
         End Set
      End Property

      Public Property ProfileProperties() As Generic.Dictionary(Of String, DotNetNuke.Entities.Profile.ProfilePropertyDefinition)
         Get
            Return _ProfileProperties
         End Get
         Set(ByVal value As Generic.Dictionary(Of String, DotNetNuke.Entities.Profile.ProfilePropertyDefinition))
            _ProfileProperties = value
         End Set
      End Property

      Public Property Base() As effority.UserDirectory.Base
         Get
            Return _Base
         End Get
         Set(ByVal value As effority.UserDirectory.Base)
            _Base = value
         End Set
      End Property

      Public Property RenderMode() As Enums.ReplaceEngineRenderMode
         Get
            Return _RenderMode
         End Get
         Set(ByVal value As Enums.ReplaceEngineRenderMode)
            _RenderMode = value
         End Set
      End Property

#End Region

#Region " Contructors "

      Public Sub New()

      End Sub

      Public Sub New(ByVal user As DotNetNuke.Entities.Users.UserInfo)

         Me._FirstName = user.FirstName
         Me._LastName = user.LastName
         Me._DisplayName = user.DisplayName
         Me._Username = user.Username
         Me._UserId = user.UserID
         Me._Email = user.Email

         For Each proPro As DotNetNuke.Entities.Profile.ProfilePropertyDefinition In user.Profile.ProfileProperties

            Me._ProfileProperties.Add(proPro.PropertyName.ToLower, proPro)

         Next

      End Sub

      ' mal schauen ob da tut
      Public Sub New(ByVal userRow As DataRowView)

         If Not userRow Is Nothing Then

            For Each col As DataColumn In userRow.Row.Table.Columns

               Select Case col.ColumnName.ToLower

                  Case "lastname"

                     Me.LastName = userRow(col.ColumnName)

                  Case "firstname"

                     Me.Firstname = userRow(col.ColumnName)

                  Case "displayname"

                     Me.DisplayName = userRow(col.ColumnName)

                  Case "email"

                     Me.Email = userRow(col.ColumnName)

                  Case Consts.USERID_COLUMN

                     Me.UserId = userRow(Consts.USERID_COLUMN)

                  Case "username"

                     Me.Username = userRow(col.ColumnName)

                  Case Else

                     Dim newProperty As New DotNetNuke.Entities.Profile.ProfilePropertyDefinition

                     newProperty.PropertyName = col.ColumnName
                     newProperty.PropertyValue = userRow(col.ColumnName)

                     Me._ProfileProperties.Add(newProperty.PropertyName.ToLower, newProperty)

               End Select

            Next

         Else

            Throw New ArgumentException("userRow is missing")

         End If

      End Sub

#End Region

#Region " Methods "

      Public Function Replace(ByVal str As String) As String
         Return MyBase.ReplaceTokens(str)
      End Function

      Protected Overrides Function replacedTokenValue(ByVal strObjectName As String, ByVal strPropertyName As String, ByVal strFormat As String) As String

         Dim result As String = String.Empty

         If Me.RenderMode = Enums.ReplaceEngineRenderMode.Grid Then

            result = Me.GridReplace(strObjectName, strPropertyName, strFormat)

         Else

            result = Me.DetailsReplace(strObjectName, strPropertyName, strFormat)

         End If

         Return result

      End Function

      Private Function GridReplace(ByVal strObjectName As String, ByVal strPropertyName As String, ByVal strFormat As String) As String

         Dim result As String = String.Empty

         Dim dnnCode As String = strPropertyName.ToLower

         ' zur ProfileName gehhrige ProfilePropertyId laden 
         Dim proId As Int32

         Select Case dnnCode.ToLower

            Case "displayname"

               proId = Consts.DISPLAYNAME_PROFILE_ID

            Case "email"

               proId = Consts.EMAIL_PROFILE_ID

            Case "username"

               proId = Consts.USERNAME_PROFILE_ID

            Case Else

               Dim profileItem As DotNetNuke.Entities.Profile.ProfilePropertyDefinition = DotNetNuke.Entities.Profile.ProfileController.GetPropertyDefinitionByName(Me.Base.PortalId, strPropertyName)

               If profileItem IsNot Nothing Then
                  proId = profileItem.PropertyDefinitionId
               End If

         End Select

         Dim mode As effority.UserDirectory.Enums.RenderMode = Enums.RenderMode.Text

         If Me.Base.DisplayEmailAsMailTo AndAlso proId = Consts.EMAIL_PROFILE_ID Then
            mode = effority.UserDirectory.Enums.RenderMode.EmailMailTo
         End If

         ' Der ProfileLink sticht den EmailLink aus
         If (Me.Base.EnableProfileLink AndAlso proId = Me.Base.ProfileLinkColumn) Then
            mode = effority.UserDirectory.Enums.RenderMode.ProfileLink
         End If

         If (Me.Base.EnablevCardLink AndAlso proId = Me.Base.vCardLinkColumn) Then
            mode = effority.UserDirectory.Enums.RenderMode.vCardLink
         End If

         If (Me.Base.detailsLinkEnable AndAlso proId = Me.Base.detailsLinkColumn) Then
            mode = effority.UserDirectory.Enums.RenderMode.detailsView
         End If

         If (Me.Base.TabLinkEnable AndAlso proId = Me.Base.TabLinkColumn) Then
            mode = effority.UserDirectory.Enums.RenderMode.tabLink
         End If

         ' Profilewert bei Bedarf krzen

         Dim value As String = String.Empty

         Select Case dnnCode.ToLower

            Case "lastname"

               value = Me._LastName

            Case "firstname"

               value = Me._FirstName

            Case "displayname"

               value = Me.DisplayName

            Case "email"

               value = Me.Email

            Case "username"

               value = Me.Username

            Case Else

               If Me.ProfileProperties.TryGetValue(dnnCode, Nothing) Then

                  value = Me.ProfileProperties(dnnCode).PropertyValue

               End If

         End Select

         If Me.Base.MaxLengthDic.TryGetValue(proId, Nothing) Then

            Dim maxLength As Int32 = Me.Base.MaxLengthDic(proId)

            If maxLength > 0 Then

               If value.Length > maxLength Then

                  value = value.Substring(0, maxLength)

               End If

            End If

         End If

         Select Case mode

            Case effority.UserDirectory.Enums.RenderMode.ProfileLink
               result = String.Format("<a href='{0}' target='_self'>{1}</a>", DotNetNuke.Common.Globals.LinkClick("UserID=" & Me.UserId, Me.Base.TabId, Me.Base.ModuleId), value)

            Case effority.UserDirectory.Enums.RenderMode.EmailMailTo
               result = String.Format("<a href='mailto:{0}'>{0}</a></td>", value)

            Case effority.UserDirectory.Enums.RenderMode.Text
               result = String.Format("{0}", value)

            Case Enums.RenderMode.vCardLink
               result = String.Format("<a href='{0}' target='_self'>" & value & "</a>", Me.Base.GetvCardLink(Me.UserId))

            Case Enums.RenderMode.detailsView
               result = String.Format("<a href='{0}' target='_self'>" & value & "</a>", Me.Base.GetDetailsViewLink(Me.UserId, String.Empty))

            Case Enums.RenderMode.tabLink

               Dim localTabId As Int32 = 0

               If Integer.TryParse(value, localTabId) AndAlso Me.Base.TabDictionary.TryGetValue(localTabId, Nothing) Then

                  Dim tabInf As Entities.Tabs.TabInfo = Me.Base.TabDictionary(localTabId)

                  result = "<a href='" & NavigateURL(localTabId) & "' target='" & Me.Base.TabLinkTarget & "'>" & tabInf.TabName & "</a>"

               End If

         End Select

         Return result

      End Function

      Private Function DetailsReplace(ByVal strObjectName As String, ByVal strPropertyName As String, ByVal strFormat As String) As String

         Dim value As String = String.Empty

         Dim dnnCode As String = strPropertyName.ToLower

         Select Case dnnCode.ToLower

            Case "lastname"

               value = Me._LastName

            Case "firstname"

               value = Me._FirstName

            Case "displayname"

               value = Me.DisplayName

            Case "email"

               value = Me.Email

            Case "username"

               value = Me.Username

            Case Else

               If Me.ProfileProperties.TryGetValue(dnnCode, Nothing) Then

                  value = Me.ProfileProperties(dnnCode).PropertyValue

                  value = HttpContext.Current.Server.HtmlDecode(value)

               End If

         End Select

         Return value

      End Function

#End Region

   End Class


   Public Class ProfilePropertyLocalization
      Inherits DotNetNuke.Services.Tokens.BaseTokenReplace

#Region " Private Members "

      Private _ProfilePropertyNamesLocal As Generic.Dictionary(Of String, String)

#End Region

#Region " Public Properties "

      Public Property ProfilePropertyNamesLocal() As Generic.Dictionary(Of String, String)
         Get
            Return _ProfilePropertyNamesLocal
         End Get
         Set(ByVal value As Generic.Dictionary(Of String, String))
            _ProfilePropertyNamesLocal = value
         End Set
      End Property

#End Region

#Region " Contructors "

      Public Sub New()

      End Sub

      Public Sub New(ByVal ProfilePropertyNamesLocal As Generic.Dictionary(Of String, String))

         _ProfilePropertyNamesLocal = ProfilePropertyNamesLocal

      End Sub

#End Region

#Region " Methods "

      Public Function Replace(ByVal str As String) As String
         Return MyBase.ReplaceTokens(str)
      End Function

      Protected Overrides Function replacedTokenValue(ByVal strObjectName As String, ByVal strPropertyName As String, ByVal strFormat As String) As String

         Dim result As String = String.Empty

         If strObjectName.ToLower = "profileproperty" Then

            _ProfilePropertyNamesLocal.TryGetValue(strPropertyName, result)

            'result = _ProfilePropertyNamesLocal(strPropertyName)

         End If

         Return result

      End Function

#End Region

   End Class
End Namespace