Imports System.Runtime.CompilerServices
Imports DotNetNuke.Entities.Profile


Imports System.Linq
Imports DotNetNuke.Common.Lists
Imports Microsoft.VisualBasic

Namespace effority.UserDirectory

    Public Class Base
        Inherits DotNetNuke.Entities.Modules.ModuleSettingsBase

#Region " Private Members "

        Private _ProfilesPropertyCollectionToShow As Generic.List(Of DotNetNuke.Entities.Profile.ProfilePropertyDefinition)
        Private _ProfilesPropertyCollectionToShowDic As Generic.Dictionary(Of Integer, DotNetNuke.Entities.Profile.ProfilePropertyDefinition)

        Private _ProfilesPropertyCollectionToSearch As Generic.List(Of DotNetNuke.Entities.Profile.ProfilePropertyDefinition)
        Private _ProfilesPropertyCollectionToFilter As Generic.List(Of DotNetNuke.Entities.Profile.ProfilePropertyDefinition)

        Private _ProfilesPropertyCollectionToLoad As Generic.List(Of DotNetNuke.Entities.Profile.ProfilePropertyDefinition)

        Private _ProfilePropertyCollection As Generic.List(Of DotNetNuke.Entities.Profile.ProfilePropertyDefinition)
        Private _ProfilePropertyCollectionDic As Generic.Dictionary(Of Integer, DotNetNuke.Entities.Profile.ProfilePropertyDefinition)
        Private _ProfilePropertyCollectionDicByName As Generic.Dictionary(Of String, DotNetNuke.Entities.Profile.ProfilePropertyDefinition)

        Private _ProfilePropertyNamesLocal As Generic.Dictionary(Of String, String)

        Private _MaxLengthDic As Generic.Dictionary(Of Integer, Integer)

        Private _HtmlDecodeDic As Generic.Dictionary(Of Integer, Boolean)

        Private _ExtendedRoleOnlyDic As Generic.Dictionary(Of Integer, Boolean)

        'Private _EnabledRoles As Generic.List(Of Integer)

        Private _PortalRoles As ArrayList

        Private _RolesConfiguration As Generic.Dictionary(Of Int32, Enums.RoleStatus)

        Private _ProfilePropertyNamesResourceFile As String = "~/Admin/Users/App_LocalResources/Profile.ascx"

        Private _TabDictionary As Generic.Dictionary(Of Int32, DotNetNuke.Entities.Tabs.TabInfo)

#End Region

#Region " Public Properties "

        Public ReadOnly Property ProfilePropertyNamesLocalDic() As Generic.Dictionary(Of String, String)

            Get

                If _ProfilePropertyNamesLocal Is Nothing Then

                    _ProfilePropertyNamesLocal = New Generic.Dictionary(Of String, String)

                    For Each item As DotNetNuke.Entities.Profile.ProfilePropertyDefinition In Me.ProfilesPropertyCollectionToShow

                        If item.PropertyDefinitionId = Consts.USERNAME_PROFILE_ID Then

                            Dim text As String = _
                            DotNetNuke.Services.Localization.Localization.GetString("User_Username", Me.LocalResourceFile)

                            If Not String.IsNullOrEmpty(text) Then
                                _ProfilePropertyNamesLocal.Add(item.PropertyName, text)
                            Else
                                _ProfilePropertyNamesLocal.Add(item.PropertyName, item.PropertyName)
                            End If

                        ElseIf item.PropertyDefinitionId = Consts.EMAIL_PROFILE_ID Then

                            Dim text As String = _
                           DotNetNuke.Services.Localization.Localization.GetString("User_Email", Me.LocalResourceFile)

                            If Not String.IsNullOrEmpty(text) Then
                                _ProfilePropertyNamesLocal.Add(item.PropertyName, text)
                            Else
                                _ProfilePropertyNamesLocal.Add(item.PropertyName, item.PropertyName)
                            End If

                        ElseIf item.PropertyDefinitionId = Consts.DISPLAYNAME_PROFILE_ID Then

                            Dim text As String = _
                           DotNetNuke.Services.Localization.Localization.GetString("User_DisplayName", Me.LocalResourceFile)

                            If Not String.IsNullOrEmpty(text) Then
                                _ProfilePropertyNamesLocal.Add(item.PropertyName, text)
                            Else
                                _ProfilePropertyNamesLocal.Add(item.PropertyName, item.PropertyName)
                            End If
                            'photo url
                        ElseIf item.PropertyDefinitionId = Consts.PHOTOURL_PROFILE_ID Then
                            Dim text As String = _
                           DotNetNuke.Services.Localization.Localization.GetString("User_PhotoUrl", Me.LocalResourceFile)

                            If Not String.IsNullOrEmpty(text) Then
                                _ProfilePropertyNamesLocal.Add(item.PropertyName, text)
                            Else
                                _ProfilePropertyNamesLocal.Add(item.PropertyName, item.PropertyName)
                            End If
                        Else

                            Dim text As String = _
                            Localization.GetString("ProfileProperties_" + item.PropertyName, _ProfilePropertyNamesResourceFile, System.Threading.Thread.CurrentThread.CurrentCulture.Name)

                            If Not String.IsNullOrEmpty(text) Then
                                _ProfilePropertyNamesLocal.Add(item.PropertyName, text)
                            Else
                                _ProfilePropertyNamesLocal.Add(item.PropertyName, item.PropertyName)
                            End If

                        End If

                    Next

                End If

                Return _ProfilePropertyNamesLocal

            End Get

        End Property

        Public ReadOnly Property ProfilesPropertyCollectionToShow() As Generic.List(Of DotNetNuke.Entities.Profile.ProfilePropertyDefinition)

            Get

                If _ProfilesPropertyCollectionToShow Is Nothing Then

                    _ProfilesPropertyCollectionToShow = New Generic.List(Of DotNetNuke.Entities.Profile.ProfilePropertyDefinition)

                    If Me.ShowAllProfiles Then

                        For Each info As DotNetNuke.Entities.Profile.ProfilePropertyDefinition In Me.ProfilePropertyCollection

                            _ProfilesPropertyCollectionToShow.Add(info)

                        Next

                    Else

                        If Not Settings(Consts.PROFILES_TO_SHOW) Is Nothing Then

                            Dim str As String = Settings(Consts.PROFILES_TO_SHOW).ToString()

                            str = str.Replace(";;", ";")

                            Dim arr As String() = str.Split(";"c)

                            For Each id As String In arr

                                If Not String.IsNullOrEmpty(id) Then

                                    If CInt(id) = Consts.USERNAME_PROFILE_ID Then

                                        _ProfilesPropertyCollectionToShow.Insert(0, Controller.FakeUsernameProfileProperty)

                                    ElseIf CInt(id) = Consts.EMAIL_PROFILE_ID Then

                                        _ProfilesPropertyCollectionToShow.Insert(0, Controller.FakeEmailProfileProperty)

                                    ElseIf CInt(id) = Consts.DISPLAYNAME_PROFILE_ID Then

                                        _ProfilesPropertyCollectionToShow.Insert(0, Controller.FakeDisplaynameProfileProperty)
                                        'photo url
                                    ElseIf CInt(id) = Consts.PHOTOURL_PROFILE_ID Then

                                        _ProfilesPropertyCollectionToShow.Insert(0, Controller.FakePhotoUrlProfileProperty)
                                    Else

                                        Dim pd As DotNetNuke.Entities.Profile.ProfilePropertyDefinition

                                        ProfilePropertyCollectionDic.TryGetValue(CInt(id), pd)

                                        If Not pd Is Nothing Then

                                            _ProfilesPropertyCollectionToShow.Add(pd)

                                        End If

                                    End If

                                End If

                            Next

                        End If

                    End If

                End If

                Return _ProfilesPropertyCollectionToShow

            End Get

        End Property

        Public ReadOnly Property ProfilesPropertyCollectionToShowDic() As Generic.Dictionary(Of Integer, DotNetNuke.Entities.Profile.ProfilePropertyDefinition)
            Get

                If _ProfilesPropertyCollectionToShowDic Is Nothing Then

                    _ProfilesPropertyCollectionToShowDic = Me.ProfilesPropertyCollectionToShow.ToDictionary(Function(x) x.PropertyDefinitionId, Function(y) y)

                End If

                Return _ProfilesPropertyCollectionToShowDic

            End Get
        End Property

        Public ReadOnly Property ProfilesPropertyCollectionToFilter() As Generic.List(Of DotNetNuke.Entities.Profile.ProfilePropertyDefinition)
            Get

                If _ProfilesPropertyCollectionToFilter Is Nothing Then
                    _ProfilesPropertyCollectionToFilter = New Generic.List(Of DotNetNuke.Entities.Profile.ProfilePropertyDefinition)

                    If Not Settings(Consts.PROFILES_TO_FILTER) Is Nothing Then

                        Dim str As String = Settings(Consts.PROFILES_TO_FILTER).ToString()

                        str = str.Replace(";;", ";")
                        Dim arr As String() = str.Split(";"c)
                        For Each id As String In arr
                            If Not String.IsNullOrEmpty(id) Then
                                'FILTERING IS ONLY POSSIBLE FOR LIST TYPE PROPERTIES
                                Dim pd As DotNetNuke.Entities.Profile.ProfilePropertyDefinition
                                ProfilePropertyCollectionDic.TryGetValue(CInt(id), pd)

                                If Not pd Is Nothing AndAlso pd.IsList Then

                                    _ProfilesPropertyCollectionToFilter.Add(pd)

                                End If
                            End If

                        Next

                    End If

                End If

                Return _ProfilesPropertyCollectionToFilter

            End Get

        End Property

        Public ReadOnly Property ProfilesPropertyCollectionToSearch() As Generic.List(Of DotNetNuke.Entities.Profile.ProfilePropertyDefinition)
            Get

                If _ProfilesPropertyCollectionToSearch Is Nothing Then

                    _ProfilesPropertyCollectionToSearch = New Generic.List(Of DotNetNuke.Entities.Profile.ProfilePropertyDefinition)

                    If Me.SearchAllProfiles Then

                        For Each info As DotNetNuke.Entities.Profile.ProfilePropertyDefinition In Me.ProfilePropertyCollection

                            _ProfilesPropertyCollectionToSearch.Add(info)

                        Next

                    Else

                        If Not Settings(Consts.PROFILES_TO_SEARCH) Is Nothing Then

                            Dim str As String = Settings(Consts.PROFILES_TO_SEARCH).ToString()

                            str = str.Replace(";;", ";")

                            Dim arr As String() = str.Split(";"c)

                            For Each id As String In arr

                                If Not String.IsNullOrEmpty(id) Then

                                    If CInt(id) = Consts.USERNAME_PROFILE_ID Then

                                        _ProfilesPropertyCollectionToSearch.Insert(0, Controller.FakeUsernameProfileProperty)

                                    ElseIf CInt(id) = Consts.EMAIL_PROFILE_ID Then

                                        _ProfilesPropertyCollectionToSearch.Insert(0, Controller.FakeEmailProfileProperty)

                                    ElseIf CInt(id) = Consts.DISPLAYNAME_PROFILE_ID Then

                                        _ProfilesPropertyCollectionToSearch.Insert(0, Controller.FakeDisplaynameProfileProperty)

                                    Else

                                        Dim pd As DotNetNuke.Entities.Profile.ProfilePropertyDefinition

                                        ProfilePropertyCollectionDic.TryGetValue(CInt(id), pd)

                                        If Not pd Is Nothing Then

                                            _ProfilesPropertyCollectionToSearch.Add(pd)

                                        End If

                                    End If

                                End If

                            Next

                        End If

                    End If

                End If


                Return _ProfilesPropertyCollectionToSearch

            End Get

        End Property

        Public ReadOnly Property ProfilePropertyCollection() As Generic.List(Of DotNetNuke.Entities.Profile.ProfilePropertyDefinition)

            Get

                If _ProfilePropertyCollection Is Nothing Then

                    Dim baseListe As DotNetNuke.Entities.Profile.ProfilePropertyDefinitionCollection = ProfileController.GetPropertyDefinitionsByPortal(PortalId)

                    _ProfilePropertyCollection = New Generic.List(Of DotNetNuke.Entities.Profile.ProfilePropertyDefinition)

                    _ProfilePropertyCollection.Insert(0, Controller.FakeUsernameProfileProperty())

                    _ProfilePropertyCollection.Insert(1, Controller.FakeDisplaynameProfileProperty)

                    _ProfilePropertyCollection.Insert(2, Controller.FakeEmailProfileProperty)

                    'photo url
                    _ProfilePropertyCollection.Insert(3, Controller.FakePhotoUrlProfileProperty)
                    For Each item As DotNetNuke.Entities.Profile.ProfilePropertyDefinition In baseListe

                        _ProfilePropertyCollection.Add(item)

                    Next

                End If

                Return _ProfilePropertyCollection

            End Get

        End Property

        Public ReadOnly Property ProfilePropertyCollectionDic() As Generic.Dictionary(Of Integer, DotNetNuke.Entities.Profile.ProfilePropertyDefinition)
            Get

                If _ProfilePropertyCollectionDic Is Nothing Then

                    _ProfilePropertyCollectionDic = Me.ProfilePropertyCollection.ToDictionary(Function(x) x.PropertyDefinitionId, Function(y) y)

                End If

                Return _ProfilePropertyCollectionDic

            End Get
        End Property

        Public ReadOnly Property ProfilePropertyCollectionDicByName() As Generic.Dictionary(Of String, DotNetNuke.Entities.Profile.ProfilePropertyDefinition)
            Get


                If _ProfilePropertyCollectionDicByName Is Nothing Then

                    _ProfilePropertyCollectionDicByName = Me.ProfilePropertyCollection.ToDictionary(Function(x) x.PropertyName, Function(y) y)

                End If

                Return _ProfilePropertyCollectionDicByName

            End Get
        End Property

        Public ReadOnly Property ProfilesPropertiesToLoad() As Generic.List(Of DotNetNuke.Entities.Profile.ProfilePropertyDefinition)
            Get

                If _ProfilesPropertyCollectionToLoad Is Nothing Then

                    _ProfilesPropertyCollectionToLoad = New Generic.List(Of DotNetNuke.Entities.Profile.ProfilePropertyDefinition)

                    If Me.SearchAllProfiles = True Or Me.ShowAllProfiles = True Then

                        For Each info As DotNetNuke.Entities.Profile.ProfilePropertyDefinition In Me.ProfilePropertyCollection

                            _ProfilesPropertyCollectionToLoad.Add(info)

                        Next

                    Else

                        Dim dic As New Generic.Dictionary(Of Int32, DotNetNuke.Entities.Profile.ProfilePropertyDefinition)

                        For Each info As DotNetNuke.Entities.Profile.ProfilePropertyDefinition In Me.ProfilesPropertyCollectionToSearch

                            dic.Add(info.PropertyDefinitionId, info)

                        Next

                        For Each info As DotNetNuke.Entities.Profile.ProfilePropertyDefinition In Me.ProfilesPropertyCollectionToFilter

                            If Not dic.TryGetValue(info.PropertyDefinitionId, Nothing) Then

                                dic.Add(info.PropertyDefinitionId, info)

                            End If

                        Next

                        For Each info As DotNetNuke.Entities.Profile.ProfilePropertyDefinition In Me.ProfilesPropertyCollectionToShow

                            If Not dic.TryGetValue(info.PropertyDefinitionId, Nothing) Then

                                dic.Add(info.PropertyDefinitionId, info)

                            End If

                        Next

                        For Each info As DotNetNuke.Entities.Profile.ProfilePropertyDefinition In dic.Values

                            _ProfilesPropertyCollectionToLoad.Add(info)

                        Next

                    End If

                End If

                Return _ProfilesPropertyCollectionToLoad

            End Get

        End Property

        Public ReadOnly Property SearchAllProfiles() As Boolean
            Get
                If Not Settings(Consts.PROFILES_SEARCH_ALL) Is Nothing Then
                    Return CBool(Settings(Consts.PROFILES_SEARCH_ALL))
                Else
                    Return True
                End If
            End Get
        End Property

        Public ReadOnly Property IgnoreEffectiveExpireDate() As Boolean
            Get

                Dim result As Boolean = False

                If Not Settings(Consts.IGNORE_EFFECTIVE_EXPIRE_DATES) Is Nothing Then
                    result = CBool(Settings(Consts.IGNORE_EFFECTIVE_EXPIRE_DATES))
                End If

                Return result
            End Get
        End Property

        Public ReadOnly Property ShowAllProfiles() As Boolean
            Get
                If Not Settings(Consts.PROFILES_SHOW_ALL) Is Nothing Then
                    Return CBool(Settings(Consts.PROFILES_SHOW_ALL))
                Else
                    Return True
                End If
            End Get
        End Property

        Public ReadOnly Property ShowProfilesToSearchSettings() As Boolean
            Get
                If Not Settings(Consts.SHOW_PROFILES_TO_SEARCH_SETTINGS) Is Nothing Then
                    Return CBool(Settings(Consts.SHOW_PROFILES_TO_SEARCH_SETTINGS))
                Else
                    Return True
                End If
            End Get
        End Property

        Public ReadOnly Property ExtendedRoleId As Integer
            Get
                Dim roleId As Integer = Null.NullInteger
                Integer.TryParse(Settings(effority.UserDirectory.Consts.EXTENDEDROLE), roleId)
                Return roleId
            End Get
        End Property

        Public ReadOnly Property ExtendedRolePage As String
            Get
                Dim retval As String = ""
                If Not Settings(effority.UserDirectory.Consts.EXTENDEDROLE_PAGE) Is Nothing Then
                    retval = Settings(effority.UserDirectory.Consts.EXTENDEDROLE_PAGE).ToString
                End If
                Return retval
            End Get
        End Property

        Public ReadOnly Property UseExtendedRolePage As Boolean
            Get
                Return Not String.IsNullOrEmpty(ExtendedRolePage)
            End Get
        End Property

        Public ReadOnly Property UseExtendedRole As Boolean
            Get
                Return ExtendedRoleId > 0
            End Get
        End Property
        Public ReadOnly Property MaxLengthDic() As Generic.Dictionary(Of Integer, Integer)
            Get

                If _MaxLengthDic Is Nothing Then

                    _MaxLengthDic = New Generic.Dictionary(Of Integer, Integer)

                    If Not String.IsNullOrEmpty(Settings(effority.UserDirectory.Consts.MAX_LENGTH)) Then

                        Dim temp As String() = Settings(effority.UserDirectory.Consts.MAX_LENGTH).ToString().Split(";")

                        For Each str As String In temp

                            If Not String.IsNullOrEmpty(str) Then

                                Dim ab As String() = str.Split("|")

                                Dim a As String = ab(0)

                                Dim b As String = ab(1)

                                If Not String.IsNullOrEmpty(a) AndAlso Not String.IsNullOrEmpty(b) Then

                                    _MaxLengthDic.Add(a, b)

                                End If

                            End If

                        Next

                    End If

                End If

                Return _MaxLengthDic

            End Get
        End Property

        Public ReadOnly Property HtmlDecodeDic() As Generic.Dictionary(Of Integer, Boolean)
            Get

                If _HtmlDecodeDic Is Nothing Then

                    _HtmlDecodeDic = New Generic.Dictionary(Of Integer, Boolean)

                    If Not String.IsNullOrEmpty(Settings(effority.UserDirectory.Consts.HTML_DECODE)) Then

                        Dim temp As String() = Settings(effority.UserDirectory.Consts.HTML_DECODE).ToString().Split(";")

                        For Each str As String In temp

                            If Not String.IsNullOrEmpty(str) Then

                                Dim ab As String() = str.Split("|")

                                Dim a As Integer = Convert.ToInt32(ab(0))

                                Dim b As Boolean = False

                                Boolean.TryParse(ab(1), b)

                                _HtmlDecodeDic.Add(a, b)

                            End If

                        Next

                    End If

                End If

                Return _HtmlDecodeDic

            End Get
        End Property

        Public ReadOnly Property ExtendedRoleOnlyDic() As Generic.Dictionary(Of Integer, Boolean)
            Get

                If _ExtendedRoleOnlyDic Is Nothing Then

                    _ExtendedRoleOnlyDic = New Generic.Dictionary(Of Integer, Boolean)

                    If Not String.IsNullOrEmpty(Settings(effority.UserDirectory.Consts.EXTENDEDROLE_PROFILES)) Then

                        Dim temp As String() = Settings(effority.UserDirectory.Consts.EXTENDEDROLE_PROFILES).ToString().Split(";")

                        For Each str As String In temp

                            If Not String.IsNullOrEmpty(str) Then

                                Dim ab As String() = str.Split("|")

                                Dim a As Integer = Convert.ToInt32(ab(0))

                                Dim b As Boolean = False

                                Boolean.TryParse(ab(1), b)

                                _ExtendedRoleOnlyDic.Add(a, b)

                            End If

                        Next

                    End If

                End If

                Return _ExtendedRoleOnlyDic

            End Get
        End Property

        Public ReadOnly Property DisplayEmailAsMailTo() As Boolean
            Get

                Dim result As Boolean = False

                If Not Settings(Consts.EMAIL_FIELD_WITH_MAILTO) Is Nothing Then
                    result = CBool(Settings(Consts.EMAIL_FIELD_WITH_MAILTO))
                End If

                Return result

            End Get
        End Property

        Public ReadOnly Property SearchStartMode() As Enums.SearchStartMode
            Get

                Dim result As Enums.SearchStartMode = Enums.SearchStartMode.ShowNoRecords

                If Not Settings(Consts.SEARCH_START_MODE) Is Nothing _
                AndAlso Not String.IsNullOrEmpty(Settings(Consts.SEARCH_START_MODE)) Then

                    result = CType(Settings(Consts.SEARCH_START_MODE), Enums.SearchStartMode)

                End If

                Return result

            End Get
        End Property

        Public ReadOnly Property UseFixSearchExpression() As Boolean
            Get

                Dim result As Boolean = False

                If Not Settings(effority.UserDirectory.Consts.DEFAULT_SEARCH_EXPRESSION) Is Nothing Then

                    If Not String.IsNullOrEmpty(CStr(Settings(effority.UserDirectory.Consts.DEFAULT_SEARCH_EXPRESSION))) Then
                        result = True
                    End If

                End If

                Return result

            End Get
        End Property

        Public ReadOnly Property DisableSearch() As Boolean
            Get

                Dim result As Boolean = False

                If Not Settings(Consts.DISABLE_SEARCH) Is Nothing AndAlso CBool(Settings(Consts.DISABLE_SEARCH)) Then
                    result = True
                End If

                Return result

            End Get
        End Property

        Public ReadOnly Property EnableProfileLink() As Boolean
            Get

                Dim result As Boolean = False

                If Not Settings(Consts.ENABLE_PROFILE_LINK) Is Nothing Then

                    result = CBool(Settings(Consts.ENABLE_PROFILE_LINK))

                End If

                Return result

            End Get
        End Property

        Public ReadOnly Property ProfileLinkColumn() As Int32
            Get

                Dim propertyId As Int32 = -1 ' username column

                If Not Settings(Consts.COLUMN_FOR_PROFILE_LINK) Is Nothing Then

                    propertyId = CInt(Settings(Consts.COLUMN_FOR_PROFILE_LINK))

                End If

                Return propertyId

            End Get
        End Property

        Public ReadOnly Property EnablevCardLink() As Boolean
            Get

                Dim result As Boolean = False

                If Not Settings(Consts.VCARD_LINK_ENABLE) Is Nothing Then

                    result = CBool(Settings(Consts.VCARD_LINK_ENABLE))

                End If

                Return result

            End Get
        End Property

        Public ReadOnly Property vCardLinkColumn() As Int32
            Get

                Dim propertyId As Int32 = -1 ' username column

                If Not Settings(Consts.VCARD_LINK_COLUMN) Is Nothing Then

                    propertyId = CInt(Settings(Consts.VCARD_LINK_COLUMN))

                End If

                Return propertyId

            End Get
        End Property

        Public ReadOnly Property vCardTemplate() As String
            Get

                Dim result As String = String.Empty

                If Not Settings(Consts.VCARD_LINK_TEMPLATE) Is Nothing Then

                    result = CStr(Settings(Consts.VCARD_LINK_TEMPLATE))

                End If

                Return result

            End Get
        End Property

        Public ReadOnly Property DefaultSortExpression() As String
            Get

                Dim direction As String = "ASC"
                Dim column As String = String.Empty

                Dim result As String = String.Empty

                If Not Settings(Consts.SORT_COLUMN) Is Nothing Then

                    If Not Settings(Consts.SORT_DIRECTION) Is Nothing Then

                        direction = CStr(Settings(Consts.SORT_DIRECTION))

                    End If

                    column = CleanColumnName(Me.ProfilePropertyCollectionDic(CInt(Settings(Consts.SORT_COLUMN))).PropertyName)

                    result = String.Format("{0} {1}", column, direction)

                End If

                Return result

            End Get
        End Property

        Public ReadOnly Property detailsLinkEnable() As Boolean
            Get

                Dim result As Boolean = False

                If Not Settings(Consts.DETAILS_VIEW_ENABLE) Is Nothing Then

                    result = CBool(Settings(Consts.DETAILS_VIEW_ENABLE))

                End If

                Return result

            End Get
        End Property

        Public ReadOnly Property detailsLinkColumn() As Int32
            Get

                Dim propertyId As Int32 = -1 ' username column

                If Not Settings(Consts.DETAILS_VIEW_COLUMN) Is Nothing Then

                    propertyId = CInt(Settings(Consts.DETAILS_VIEW_COLUMN))

                End If

                Return propertyId

            End Get
        End Property

        Public ReadOnly Property detailsTemplate() As String
            Get

                Dim result As String = String.Empty

                If Not Settings(Consts.DETAILS_VIEW_TEMPLATE) Is Nothing Then

                    result = CStr(Settings(Consts.DETAILS_VIEW_TEMPLATE))

                End If

                Return result

            End Get
        End Property

        Public ReadOnly Property TabLinkEnable() As Boolean
            Get

                Dim result As Boolean = False

                If Not Settings(Consts.TAB_LINK_ENABLE) Is Nothing Then

                    result = CBool(Settings(Consts.TAB_LINK_ENABLE))

                End If

                Return result

            End Get
        End Property

        Public ReadOnly Property TabLinkTarget() As String
            Get

                Dim result As String = "_self"

                If Not Settings(Consts.TAB_LINK_NEW_WINDOW) Is Nothing AndAlso CStr(Settings(Consts.TAB_LINK_NEW_WINDOW)) Then

                    result = "_blank"

                End If

                Return result

            End Get
        End Property

        Public ReadOnly Property TabLinkColumn() As Int32
            Get

                Dim propertyId As Int32 = Consts.USERNAME_PROFILE_ID

                If Not Settings(Consts.TAB_LINK_COLUMN) Is Nothing Then

                    propertyId = CInt(Settings(Consts.TAB_LINK_COLUMN))

                End If

                Return propertyId

            End Get
        End Property

        'Public ReadOnly Property TabLinkText() As String
        '   Get

        '      Dim result As String = String.Empty

        '      If Not Settings(Consts.TAB_LINK_TEXT) Is Nothing Then

        '         result = CStr(Settings(Consts.TAB_LINK_TEXT))

        '      End If

        '      Return result

        '   End Get
        'End Property

        Public ReadOnly Property MinChar() As Int32
            Get

                Dim _minChar As Int32 = 1

                If Not Settings(Consts.MIN_CHAR) Is Nothing Then

                    _minChar = CInt(Settings(Consts.MIN_CHAR))

                End If

                Return _minChar

            End Get
        End Property

        Public ReadOnly Property PortalRoles() As ArrayList
            Get

                If _PortalRoles Is Nothing Then

                    _PortalRoles = New ArrayList

                    Dim roleCont As New DotNetNuke.Security.Roles.RoleController

                    Dim RolesWithRegisteredUsersRole As ArrayList = roleCont.GetPortalRoles(Me.PortalId)

                    For Each role As DotNetNuke.Security.Roles.RoleInfo In RolesWithRegisteredUsersRole

                        If Not role.RoleID = PortalSettings.RegisteredRoleId Then

                            _PortalRoles.Add(role)

                        End If

                    Next

                End If

                Return _PortalRoles

            End Get
        End Property

        Public ReadOnly Property RolesConfiguration() As Generic.Dictionary(Of Int32, Enums.RoleStatus)
            Get

                If _RolesConfiguration Is Nothing Then

                    _RolesConfiguration = New Generic.Dictionary(Of Int32, Enums.RoleStatus)

                    If Not String.IsNullOrEmpty(CStr(Settings(Consts.ADD_ROLES))) Then

                        Dim addRoles As String() = CStr(Settings(Consts.ADD_ROLES)).Split(";"c)

                        For Each str As String In addRoles
                            If Not String.IsNullOrEmpty(str) Then
                                _RolesConfiguration.Add(CInt(str), Enums.RoleStatus.Add)
                            End If
                        Next

                    End If

                    If Not String.IsNullOrEmpty(CStr(Settings(Consts.REMOVE_ROLES))) Then

                        Dim removeRoles As String() = CStr(Settings(Consts.REMOVE_ROLES)).Split(";"c)

                        For Each str As String In removeRoles
                            If Not String.IsNullOrEmpty(str) Then
                                _RolesConfiguration.Add(CInt(str), Enums.RoleStatus.Remove)
                            End If
                        Next

                    End If

                    If Not String.IsNullOrEmpty(CStr(Settings(Consts.IGNORE_ROLES))) Then

                        Dim ignoreRoles As String() = CStr(Settings(Consts.IGNORE_ROLES)).Split(";"c)

                        For Each str As String In ignoreRoles
                            If Not String.IsNullOrEmpty(str) Then
                                _RolesConfiguration.Add(CInt(str), Enums.RoleStatus.Ignore)
                            End If
                        Next

                    End If

                    ' Standwerte fr nicht konfigurierte Rolen erzeugen 

                    Dim rolesCont As New DotNetNuke.Security.Roles.RoleController

                    Dim roles As ArrayList = rolesCont.GetPortalRoles(PortalId)

                    For Each role As DotNetNuke.Security.Roles.RoleInfo In roles

                        If Not _RolesConfiguration.TryGetValue(role.RoleID, Nothing) Then

                            If role.RoleID = PortalSettings.AdministratorRoleId Then

                                _RolesConfiguration.Add(role.RoleID, Enums.RoleStatus.Remove)

                            Else

                                _RolesConfiguration.Add(role.RoleID, Enums.RoleStatus.Add)

                            End If

                        End If

                    Next

                End If

                Return _RolesConfiguration

            End Get
        End Property

        Public ReadOnly Property UserTableCacheKey() As String
            Get
                Return Consts.MODULE_BASE & "." & ModuleId
            End Get
        End Property

        Public ReadOnly Property USERTABLE_MODULE_CACHE() As String
            Get
                Return Consts.USERTABLE_CACHE & Me.ModuleId
            End Get
        End Property

        Public ReadOnly Property SESSION_KEY() As String
            Get
                Return Consts.MODULE_BASE & Me.ModuleId
            End Get
        End Property

        Public ReadOnly Property SESSION_SORT_EXPRESSION() As String
            Get
                Return SESSION_KEY & "SortExpression"
            End Get
        End Property

        Public ReadOnly Property SESSION_PAGE() As String
            Get
                Return SESSION_KEY & "Page"
            End Get
        End Property

        Public ReadOnly Property SESSION_QUERY_STRING_SEARCH() As String
            Get
                Return SESSION_KEY & "QueryStringSearch"
            End Get
        End Property

        Public ReadOnly Property SESSION_LASTSEARCH() As String
            Get
                Return Consts.MODULE_BASE & "." & ModuleId & "." & "LastSearch"
            End Get
        End Property

        Public ReadOnly Property DisplayMode() As Enums.DisplayMode
            Get

                Dim result As Enums.DisplayMode = Enums.DisplayMode.Grid

                If Not Settings(Consts.DISPLAY_MODE) Is Nothing Then

                    result = CType(Settings(Consts.DISPLAY_MODE), Enums.DisplayMode)

                End If

                Return result

                'Return Enums.DisplayMode.Grid
                'Return Enums.DisplayMode.Template

            End Get
        End Property

        Public ReadOnly Property DisplayTemplate() As String
            Get

                Dim result As String = String.Empty

                If Not Settings(Consts.DISPLAY_TEMPLATE) Is Nothing Then

                    result = CStr(Settings(Consts.DISPLAY_TEMPLATE))

                End If

                Return result

            End Get
        End Property

        Public ReadOnly Property DisplayHeadTemplate() As String
            Get

                Dim result As String = String.Empty

                If Not Settings(Consts.DISPLAY_HEAD_TEMPLATE) Is Nothing Then

                    result = CStr(Settings(Consts.DISPLAY_HEAD_TEMPLATE))

                End If

                Return result

            End Get
        End Property

        Public ReadOnly Property TabDictionary() As Generic.Dictionary(Of Int32, DotNetNuke.Entities.Tabs.TabInfo)
            Get

                If Me._TabDictionary Is Nothing Then

                    Dim tabCont As New Entities.Tabs.TabController

                    Me._TabDictionary = tabCont.GetTabsByPortal(Me.PortalId)

                End If

                Return Me._TabDictionary

            End Get
        End Property



#End Region

#Region " Methods "

        Public Function CleanColumnName(ByVal columnName As String) As String

            Return DotNetNuke.Common.Utilities.HtmlUtils.StripNonWord(columnName, False).Replace(" ", "")

        End Function

        Public Function BuildSearchExpression(ByVal searchString As String, ByVal filterString As String) As String

            Dim result As String = String.Empty

            Dim fixExpression As String = String.Empty
            Dim dynExpression As String = String.Empty
            Dim ftrExpression As String = String.Empty

            If UseFixSearchExpression Then
                fixExpression = CStr(Settings(Consts.DEFAULT_SEARCH_EXPRESSION))
            End If

            If Not String.IsNullOrEmpty(searchString) Then
                dynExpression = BuildDynamicFilter(searchString)
            End If
            If Not String.IsNullOrEmpty(filterString) Then
                ftrExpression = BuildStaticFilter(filterString)
            End If

            If Not String.IsNullOrEmpty(fixExpression) Then
                result = String.Format("({0})", fixExpression)
            End If
            If Not String.IsNullOrEmpty(dynExpression) Then
                If Not String.IsNullOrEmpty(result) Then result &= " AND "
                result = String.Format("({0})", dynExpression)
            End If
            If Not String.IsNullOrEmpty(ftrExpression) Then
                If Not String.IsNullOrEmpty(result) Then result &= " AND "
                result = String.Format("({0})", ftrExpression)
            End If

            Return result

        End Function

        Public Function BuildDynamicFilter(ByVal searchKey As String) As String

            Dim search As String = String.Empty

            For i As Int32 = 0 To ProfilesPropertyCollectionToSearch.Count - 1

                search &= CleanColumnName(ProfilesPropertyCollectionToSearch(i).PropertyName) & " like '%" & searchKey & "%'"

                If Not i = ProfilesPropertyCollectionToSearch.Count - 1 Then
                    search &= " or "
                End If
            Next

            Return search

        End Function

        Public Function BuildStaticFilter(ByVal filterString As String) As String

            Dim search As String = String.Empty

            Dim filters As String() = filterString.Split("#")

            For i As Int32 = 0 To filters.Count - 1

                'that's a nice condition:
                ' - filter contains "=" otherwise it's not valid
                ' - right-hand side of equation contains a value
                If filters(i).Contains("=") _
                    AndAlso Not String.IsNullOrEmpty(filters(i).Split("=")(1)) Then
                    If search.Length > 0 Then search &= " AND "
                    search &= filters(i).Trim().Replace("=", "='") & "'"
                End If

            Next

            Return search

        End Function

        Public Function GetvCardLink(ByVal UserId As Int32) As String

            Dim Request As System.Web.HttpRequest = System.Web.HttpContext.Current.Request

            Dim RequestUrl As Uri = Request.Url

            Dim port As String

            If Not RequestUrl.IsDefaultPort Then
                port = String.Format(":{0}", Request.Url.Port)
            End If

            Return String.Format("{0}://{1}{2}{3}/DesktopModules/effority.UserDirectory/vCard.aspx?UserId={4}&ModuleId={5}&TabModuleId={6}", RequestUrl.Scheme, RequestUrl.Host, port, Request.ApplicationPath, CStr(UserId), CStr(Me.ModuleId), CStr(Me.TabModuleId))

        End Function

        Public Function GetDetailsViewLink(ByVal UserId As Int32, ByVal searchText As String) As String

            Dim url As String = String.Empty

            url = DotNetNuke.Common.Globals.NavigateURL(TabId, String.Empty, "Detail=true", "ModuleId=" & CStr(ModuleId), "UserId=" & CStr(UserId), IIf(searchText.Trim().Length > 0, "SearchString=" & searchText, Nothing))

            Return url

        End Function

#End Region

    End Class

End Namespace
