Imports Microsoft.VisualBasic

Imports DotNetNuke.Common.Utilities
Imports DotNetNuke.Data

Namespace effority.UserDirectory

   Public Class Controller

      Public Shared Function GetUserProfiles() As Generic.List(Of effority.UserDirectory.UserProfile)

         Dim TablePrafix As String = effority.UserDirectory.DataProviderInformation.DatabaseOwner & effority.UserDirectory.DataProviderInformation.ObjectQualifier

         'Private _ProfileId As Integer
         'Private _UserId As Integer
         'Private _PropertyDefinitionId As Integer
         'Private _PropertyValue As String
         'Private _PropertyText As String
         'Private _Visibility As Integer

         Dim sql As String = String.Format("SELECT ProfileId, UserId, PropertyDefinitionId, PropertyValue, PropertyText, Visibility FROM {0}UserPortals", TablePrafix)

         Dim userProfilesList As New Generic.List(Of effority.UserDirectory.UserProfile)

         Dim reader As IDataReader = DotNetNuke.Data.DataProvider.Instance.ExecuteSQL(sql)

         If Not reader Is Nothing Then

            While reader.Read()

               Dim info As New UserProfile

               If Not reader.IsDBNull(0) Then
                  info.ProfileId = reader.GetInt32(0)
               Else

               End If

               If Not reader.IsDBNull(1) Then
                  info.UserId = reader.GetInt32(1)
               Else

               End If

               If Not reader.IsDBNull(2) Then
                  info.PropertyDefinitionId = reader.GetInt32(2)
               Else

               End If

               If Not reader.IsDBNull(3) Then
                  info.PropertyValue = reader.GetString(3)
               Else
                  info.PropertyValue = DotNetNuke.Common.Utilities.Null.NullString
               End If

               If Not reader.IsDBNull(4) Then
                  info.PropertyText = reader.GetString(4)
               Else
                  info.PropertyText = Null.NullString
               End If

               If Not reader.IsDBNull(5) Then
                  info.Visibility = reader.GetInt32(5)
               Else
                  info.Visibility = Null.NullInteger
               End If

               userProfilesList.Add(info)

            End While

         End If

         Return userProfilesList

      End Function

      Public Shared Function GetProfilePropertyDefinitions() As Generic.List(Of effority.UserDirectory.ProfilePropertyDefinition)

         ' TODO: SuperUser Profile Werte Rausfiltern

         Dim TablePrafix As String = effority.UserDirectory.DataProviderInformation.DatabaseOwner & effority.UserDirectory.DataProviderInformation.ObjectQualifier

         'Private _PropertyDefinitionID As Integer
         'Private _PortalId As Integer
         'Private _DefaultValue As String
         'Private _PropertyCategory As String
         'Private _PropertyName As String
         'Private _Visible As Boolean

         Dim sql As String = String.Format("SELECT PropertyDefinitionID, PortalId, DefaultValue, PropertyCategory, PropertyName, Visible FROM {0}ProfilePropertyDefinition", TablePrafix)

         Dim profilePropertyDefinitionsList As New Generic.List(Of effority.UserDirectory.ProfilePropertyDefinition)

         Dim reader As IDataReader = DataProvider.Instance.ExecuteSQL(sql)

         If Not reader Is Nothing Then

            While reader.Read()

               Dim info As New ProfilePropertyDefinition

               If Not reader.IsDBNull(0) Then
                  info.PropertyDefinitionID = reader.GetInt32(0)
               Else

               End If

               If Not reader.IsDBNull(1) Then
                  info.PortalId = reader.GetInt32(1)
               Else

               End If

               If Not reader.IsDBNull(2) Then
                  info.DefaultValue = reader.GetString(2)
               Else

               End If

               If Not reader.IsDBNull(3) Then
                  info.PropertyCategory = reader.GetString(3)
               Else

               End If

               If Not reader.IsDBNull(4) Then
                  info.PropertyName = reader.GetString(4)
               Else

               End If

               If Not reader.IsDBNull(5) Then
                  info.Visible = reader.GetBoolean(5)
               Else

               End If

               profilePropertyDefinitionsList.Add(info)

            End While

         End If

         Return profilePropertyDefinitionsList

      End Function

      Public Shared Function GetUserPortals() As Generic.List(Of effority.UserDirectory.UserPortals)

         Dim TablePrafix As String = effority.UserDirectory.DataProviderInformation.DatabaseOwner & effority.UserDirectory.DataProviderInformation.ObjectQualifier

         Dim sql As String = String.Format("SELECT UserPortalId, UserId, PortalId, Authorized FROM {0}UserPortals", TablePrafix)

         Dim userPortalsList As New Generic.List(Of effority.UserDirectory.UserPortals)

         Dim reader As IDataReader = DataProvider.Instance.ExecuteSQL(sql)

         If Not reader Is Nothing Then

            While reader.Read()

               Dim info As New UserPortals

               If Not reader.IsDBNull(0) Then
                  info.UserPortalId = reader.GetInt32(0)
               End If

               If Not reader.IsDBNull(1) Then
                  info.UserId = reader.GetInt32(1)
               End If

               If Not reader.IsDBNull(2) Then
                  info.PortalId = reader.GetInt32(2)
               End If

               If Not reader.IsDBNull(3) Then
                  info.Autherised = reader.GetBoolean(3)
               Else
                  info.Autherised = Null.NullBoolean
               End If

               userPortalsList.Add(info)

            End While

         End If

         Return userPortalsList

      End Function

      Public Shared Function GetUserRoles() As Generic.List(Of effority.UserDirectory.UserRoles)

         Dim TablePrafix As String = effority.UserDirectory.DataProviderInformation.DatabaseOwner & effority.UserDirectory.DataProviderInformation.ObjectQualifier

         Dim sql As String = String.Format("SELECT UserRoleId, UserId, RoleId, EffectiveDate, ExpiryDate FROM {0}UserRoles", TablePrafix)

         Dim userRolesList As New Generic.List(Of effority.UserDirectory.UserRoles)

         Dim reader As IDataReader = DataProvider.Instance.ExecuteSQL(sql)

         If Not reader Is Nothing Then

            While reader.Read()

               Dim info As New UserRoles

               If Not reader.IsDBNull(0) Then
                  info.UserRolesId = reader.GetInt32(0)
               End If
               If Not reader.IsDBNull(1) Then
                  info.UserId = reader.GetInt32(1)
               End If

               If Not reader.IsDBNull(2) Then
                  info.RoleId = reader.GetInt32(2)
               End If

               If Not reader.IsDBNull(3) Then
                  info.EffectiveDate = reader.GetDateTime(3)
               Else
                  info.EffectiveDate = Null.NullDate
               End If

               If Not reader.IsDBNull(4) Then
                  info.ExpiryDate = reader.GetDateTime(4)
               Else
                  info.ExpiryDate = Null.NullDate
               End If

               userRolesList.Add(info)

            End While

         End If

         Return userRolesList

      End Function

      Public Shared Function GetUsers() As Generic.List(Of effority.UserDirectory.UserIdAndUserName)

         Dim TablePrafix As String = effority.UserDirectory.DataProviderInformation.DatabaseOwner & effority.UserDirectory.DataProviderInformation.ObjectQualifier

         Dim sql As String = String.Format("SELECT UserID, Username, Email FROM {0}Users Where IsSuperUser = 0", TablePrafix)

         Dim UserInfos As New Generic.List(Of effority.UserDirectory.UserIdAndUserName)

         Dim reader As IDataReader = DataProvider.Instance.ExecuteSQL(sql)

         If Not reader Is Nothing Then

            While reader.Read()

               UserInfos.Add(New effority.UserDirectory.UserIdAndUserName(CInt(Null.SetNull(reader.GetInt32(0), Null.NullInteger)), _
                                                                           CStr(Null.SetNull(reader.GetString(1), Null.NullString)), _
                                                                           CStr(Null.SetNull(reader.GetString(2), Null.NullString))))

            End While

         End If

         Return UserInfos

      End Function

      Public Shared Function GetUsersInPortal(ByVal PortalId As Int32) As Generic.List(Of effority.UserDirectory.UserIdAndUserName)

         Dim UserIds As New Generic.List(Of effority.UserDirectory.UserIdAndUserName)

         Dim arr As ArrayList = DotNetNuke.Entities.Users.UserController.GetUsers(PortalId)

         Dim UserInfos As New Generic.List(Of effority.UserDirectory.UserIdAndUserName)

         For Each info As DotNetNuke.Entities.Users.UserInfo In arr

            UserInfos.Add(New effority.UserDirectory.UserIdAndUserName(info.UserID, info.Username, info.Email))

         Next

         Return UserInfos

      End Function

      Public Shared Function GetUsersInRolesOld(ByVal RoleIds As Generic.List(Of Integer)) As Generic.List(Of effority.UserDirectory.UserIdAndUserName)

         Dim TablePrafix As String = effority.UserDirectory.DataProviderInformation.DatabaseOwner & effority.UserDirectory.DataProviderInformation.ObjectQualifier

         Dim sql As String = String.Format("SELECT Distinct UR.UserID, U.Username, U.Email " & _
                             "FROM {0}UserRoles AS UR INNER JOIN {0}Users AS U ON UR.UserID = U.UserID", TablePrafix)

         Dim UserInfos As Generic.List(Of effority.UserDirectory.UserIdAndUserName)

         If Not RoleIds Is Nothing AndAlso RoleIds.Count > 0 Then

            sql &= " Where "

            For i As Int32 = 0 To RoleIds.Count - 1

               sql &= "(UR.RoleId = " & CStr(RoleIds(i) & ")")

               If i < RoleIds.Count - 1 Then

                  sql &= " OR "

               End If

            Next

            Dim reader As IDataReader = DataProvider.Instance.ExecuteSQL(sql)

            UserInfos = New Generic.List(Of effority.UserDirectory.UserIdAndUserName)

            While reader.Read()

               UserInfos.Add(New effority.UserDirectory.UserIdAndUserName(CInt(Null.SetNull(reader.GetInt32(0), Null.NullInteger)), _
                                                                          CStr(Null.SetNull(reader.GetString(1), Null.NullString)), _
                                                                          CStr(Null.SetNull(reader.GetString(2), Null.NullString))))

            End While

         End If

         Return UserInfos

      End Function

      Public Shared Function GetUsersInRoles(ByVal RolesStatus As Generic.Dictionary(Of Int32, Enums.RoleStatus), ByVal ignoreEffectiveExpire As Boolean) As Generic.List(Of effority.UserDirectory.UserIdAndUserName)

         Dim TablePrafix As String = effority.UserDirectory.DataProviderInformation.DatabaseOwner & effority.UserDirectory.DataProviderInformation.ObjectQualifier

         Dim sql01 As String = String.Format("SELECT Distinct UR.UserID, U.Username, U.Email, U.DisplayName " & _
                                "FROM {0}UserRoles AS UR INNER JOIN {0}Users AS U ON UR.UserID = U.UserID", TablePrafix)

         Dim AddUserInfos As New Generic.Dictionary(Of Int32, effority.UserDirectory.UserIdAndUserName)

         Dim RemoveUserInfos As New Generic.List(Of effority.UserDirectory.UserIdAndUserName)

         If Not RolesStatus Is Nothing AndAlso RolesStatus.Count > 0 Then

            Dim AreThereRolesToAdd As Boolean = False

            sql01 &= " Where"

            sql01 &= " ("

            For Each item As Generic.KeyValuePair(Of Int32, Enums.RoleStatus) In RolesStatus

               Select Case item.Value

                  Case Enums.RoleStatus.Add

                     AreThereRolesToAdd = True

                     sql01 &= "UR.RoleId = " & CStr(item.Key) & " OR "

               End Select

            Next

            sql01 = sql01.Substring(0, sql01.Length - 4)

            sql01 &= ")"

            If Not ignoreEffectiveExpire Then

               sql01 &= " AND ((EffectiveDate < GETDATE() OR EffectiveDate IS NULL) AND (ExpiryDate > GETDATE() OR  ExpiryDate IS NULL))"

            End If

            If AreThereRolesToAdd Then

               Dim reader As IDataReader = DataProvider.Instance.ExecuteSQL(sql01)

               While reader.Read()

                  AddUserInfos.Add(CInt(Null.SetNull(reader.GetInt32(0), Null.NullInteger)), New effority.UserDirectory.UserIdAndUserName(CInt(Null.SetNull(reader.GetInt32(0), Null.NullInteger)), _
                                                                             CStr(Null.SetNull(reader.GetString(1), Null.NullString)), _
                                                                             CStr(Null.SetNull(reader.GetString(2), Null.NullString)), _
                                                                             CStr(Null.SetNull(reader.GetString(3), Null.NullString))))

               End While

            End If

            ' Remove Users

            Dim sql02 As String = String.Format("SELECT Distinct UR.UserID, U.Username, U.Email, U.DisplayName  " & _
                                   "FROM {0}UserRoles AS UR INNER JOIN {0}Users AS U ON UR.UserID = U.UserID", TablePrafix)

            Dim AreThereRolesToRemove As Boolean = False

            sql02 &= " Where"

            sql02 &= " ("

            For Each item As Generic.KeyValuePair(Of Int32, Enums.RoleStatus) In RolesStatus

               Select Case item.Value

                  Case Enums.RoleStatus.Remove

                     AreThereRolesToRemove = True

                     sql02 &= "UR.RoleId = " & CStr(item.Key) & " OR "

               End Select

            Next

            sql02 = sql02.Substring(0, sql02.Length - 4)

            sql02 &= ")"

            If Not ignoreEffectiveExpire Then

               sql02 &= " AND ((EffectiveDate < GETDATE() OR EffectiveDate IS NULL) AND (ExpiryDate > GETDATE() OR  ExpiryDate IS NULL))"

            End If

            If AreThereRolesToRemove Then

               Dim reader As IDataReader = DataProvider.Instance.ExecuteSQL(sql02)

               While reader.Read()

                  RemoveUserInfos.Add(New effority.UserDirectory.UserIdAndUserName(CInt(Null.SetNull(reader.GetInt32(0), Null.NullInteger)), _
                                                                             CStr(Null.SetNull(reader.GetString(1), Null.NullString)), _
                                                                             CStr(Null.SetNull(reader.GetString(2), Null.NullString)), _
                                                                             CStr(Null.SetNull(reader.GetString(3), Null.NullString))))

               End While

            End If

         End If

         If Not RemoveUserInfos Is Nothing Then

            For Each info As effority.UserDirectory.UserIdAndUserName In RemoveUserInfos

               If AddUserInfos.TryGetValue(info.UserId, Nothing) Then

                  AddUserInfos.Remove(info.UserId)

               End If

            Next

         End If

         Dim UserInfos As New Generic.List(Of effority.UserDirectory.UserIdAndUserName)

         If Not AddUserInfos Is Nothing Then

            For Each info As effority.UserDirectory.UserIdAndUserName In AddUserInfos.Values

               UserInfos.Add(info)

            Next

         End If

         Return UserInfos

      End Function

      Public Shared Function GetUserRolesDic(ByVal PortalId As Int32, ByVal RoleName As String, ByVal RoleId As Int32) As Generic.Dictionary(Of Int32, Int32)

         Dim dic As New Generic.Dictionary(Of Integer, Integer)

         Dim roleCont As New DotNetNuke.Security.Roles.RoleController

         Dim roleArr As ArrayList = roleCont.GetUserRolesByRoleName(PortalId, RoleName)

         For Each info As DotNetNuke.Entities.Users.UserRoleInfo In roleArr

            dic.Add(info.UserID, RoleId)

         Next

         Return dic

      End Function

      Public Shared Function GetRolesDic(ByVal PortalId As Int32) As Generic.Dictionary(Of Int32, DotNetNuke.Security.Roles.RoleInfo)

         Dim dic As New Generic.Dictionary(Of Int32, DotNetNuke.Security.Roles.RoleInfo)

         Dim list As Generic.List(Of DotNetNuke.Security.Roles.RoleInfo) = GetRolesList(PortalId)

         If Not list Is Nothing Then

            For Each info As DotNetNuke.Security.Roles.RoleInfo In list

               dic.Add(info.RoleID, info)

            Next

         End If

         Return dic

      End Function

      Public Shared Function GetRolesList(ByVal PortalId As Int32) As Generic.List(Of DotNetNuke.Security.Roles.RoleInfo)

         Dim list As New Generic.List(Of DotNetNuke.Security.Roles.RoleInfo)

         Dim roleCont As New DotNetNuke.Security.Roles.RoleController

         Dim PSettings As DotNetNuke.Entities.Portals.PortalSettings = DotNetNuke.Entities.Portals.PortalController.GetCurrentPortalSettings()

         Dim arrList As ArrayList = roleCont.GetPortalRoles(PortalId)

         If Not arrList Is Nothing Then

            For Each info As DotNetNuke.Security.Roles.RoleInfo In arrList

               If Not info.RoleID = PSettings.RegisteredRoleId Then

                  list.Add(info)

               End If

            Next

         End If

         Return list

      End Function

      Public Shared Function GetUserProfileDic(ByVal ProfileDefinitions As Generic.List(Of DotNetNuke.Entities.Profile.ProfilePropertyDefinition), ByVal PortalId As Int32) As Generic.Dictionary(Of Integer, Generic.Dictionary(Of Integer, String))

         Dim TablePrafix As String = effority.UserDirectory.DataProviderInformation.DatabaseOwner & effority.UserDirectory.DataProviderInformation.ObjectQualifier

         Dim sql As String = String.Format("SELECT UserID, PropertyDefinitionID, PropertyValue " & _
                             " FROM {0}UserProfile ", TablePrafix)

         Dim userDic As Generic.Dictionary(Of Integer, Generic.Dictionary(Of Integer, String))

         If Not ProfileDefinitions Is Nothing AndAlso ProfileDefinitions.Count > 0 Then

            sql &= "WHERE "

            For i As Int32 = 0 To ProfileDefinitions.Count - 1

               sql &= "(PropertyDefinitionId = " & ProfileDefinitions(i).PropertyDefinitionId & ")"

               If i < ProfileDefinitions.Count - 1 Then

                  sql &= " OR "

               End If

            Next

            Dim reader As IDataReader = DataProvider.Instance.ExecuteSQL(sql)

            If Not reader Is Nothing Then

               ' UserId, PropertyDefinitionId, Value

               userDic = New Generic.Dictionary(Of Integer, Generic.Dictionary(Of Integer, String))

               While reader.Read

                  Dim workDic As Generic.Dictionary(Of Integer, String)

                  Dim UserId As Integer = reader.GetInt32(0)
                  Dim PropertyDefinitionId As Integer = reader.GetInt32(1)
                  Dim PropertyValue As String = Null.SetNull(reader.GetString(2), Null.NullString).ToString

                  If userDic.TryGetValue(UserId, workDic) Then

                     ' es gibt bereits Werte fr diesen User

                     If Not userDic(UserId).TryGetValue(PropertyDefinitionId, Nothing) Then

                        ' es kann in der praxis zu doppelten Werte fr eine PropertyDefinitionId pro User kommen
                        ' deshalb wird hier abgeprft ob bereits ein Wert existiert

                        userDic(UserId).Add(PropertyDefinitionId, PropertyValue)

                     End If

                  Else

                     ' fr den User war noch kein Wert vorhanden 

                     workDic = New Generic.Dictionary(Of Integer, String)

                     workDic.Add(PropertyDefinitionId, PropertyValue)

                     userDic.Add(UserId, workDic)

                  End If

                  ' old version 12.05.2008

                  'If CInt(Null.SetNull(reader.GetInt32(0), Null.NullInteger)) <> Null.NullInteger Or _
                  '   CInt(Null.SetNull(reader.GetInt32(1), Null.NullInteger)) <> Null.NullInteger Then

                  '   If userDic.TryGetValue(reader.GetInt32(0), workDic) Then

                  '      If Not userDic(reader.GetInt32(0)).TryGetValue(reader.GetInt32(1), Nothing) Then

                  '         userDic(reader.GetInt32(0)).Add(reader.GetInt32(1), _
                  '                                         CStr(Null.SetNull(reader.GetString(2), Null.NullString)))

                  '      End If

                  '   Else

                  '      workDic = New Generic.Dictionary(Of Integer, String)

                  '      workDic.Add(reader.GetInt32(1), CStr(Null.SetNull(reader.GetString(2), Null.NullString)))

                  '      userDic.Add(reader.GetInt32(0), workDic)

                  '   End If

                  'End If

               End While

            End If

         End If

         Return userDic

      End Function

      Public Shared Function FakeEmailProfileProperty() As DotNetNuke.Entities.Profile.ProfilePropertyDefinition

         Dim newPro As New DotNetNuke.Entities.Profile.ProfilePropertyDefinition
         newPro.PropertyDefinitionId = Consts.EMAIL_PROFILE_ID
         newPro.PropertyName = "Email"

         Return newPro

      End Function

      Public Shared Function FakeUsernameProfileProperty() As DotNetNuke.Entities.Profile.ProfilePropertyDefinition

         Dim newPro As New DotNetNuke.Entities.Profile.ProfilePropertyDefinition
         newPro.PropertyDefinitionId = Consts.USERNAME_PROFILE_ID
         newPro.PropertyName = "Username"

         Return newPro

      End Function


      Public Shared Function FakeDisplaynameProfileProperty() As DotNetNuke.Entities.Profile.ProfilePropertyDefinition

         Dim newPro As New DotNetNuke.Entities.Profile.ProfilePropertyDefinition
         newPro.PropertyDefinitionId = Consts.DISPLAYNAME_PROFILE_ID
         newPro.PropertyName = "Displayname"

         Return newPro

        End Function

        ' photo url
        Public Shared Function FakePhotoUrlProfileProperty() As DotNetNuke.Entities.Profile.ProfilePropertyDefinition

            Dim newPro As New DotNetNuke.Entities.Profile.ProfilePropertyDefinition
            newPro.PropertyDefinitionId = Consts.PHOTOURL_PROFILE_ID
            newPro.PropertyName = "PhotoUrl"

            Return newPro

        End Function
   End Class

End Namespace